%{?scl:%scl_package eclipse-recommenders}
%{!?scl:%global pkg_name %{name}}

%global baserelease 2

%global git_tag %{version}

Name:           %{?scl_prefix}eclipse-recommenders
Version:        2.5.0
Release:        1.%{baserelease}%{?dist}
Summary:        Eclipse Code Recommenders
License:        EPL
URL:            https://www.eclipse.org/recommenders/

Source0:        http://git.eclipse.org/c/recommenders/org.eclipse.recommenders.git/snapshot/org.eclipse.recommenders-%{git_tag}.tar.xz

BuildArch:      noarch

# Allow building against newer versions of guava
Patch0:         guava-compat.patch

# Allow building against newer versions of lucene
Patch1:         lucene-compat.patch

BuildRequires:  %{?scl_prefix_maven}maven-local
BuildRequires:  %{?scl_prefix_maven}mvn(com.google.code.findbugs:jsr305)
BuildRequires:  %{?scl_prefix_maven}mvn(org.apache.maven.plugins:maven-clean-plugin)
BuildRequires:  %{?scl_prefix_maven}mvn(org.apache.maven.plugins:maven-remote-resources-plugin)
BuildRequires:  %{?scl_prefix}mvn(org.eclipse.tycho.extras:tycho-eclipserun-plugin)
BuildRequires:  %{?scl_prefix}mvn(org.eclipse.tycho.extras:tycho-source-feature-plugin)
BuildRequires:  %{?scl_prefix}mvn(org.eclipse.tycho:target-platform-configuration)
BuildRequires:  %{?scl_prefix}mvn(org.eclipse.tycho:tycho-compiler-plugin)
BuildRequires:  %{?scl_prefix}mvn(org.eclipse.tycho:tycho-maven-plugin)
BuildRequires:  %{?scl_prefix}mvn(org.eclipse.tycho:tycho-p2-plugin)
BuildRequires:  %{?scl_prefix}mvn(org.eclipse.tycho:tycho-packaging-plugin)
BuildRequires:  %{?scl_prefix}mvn(org.eclipse.tycho:tycho-source-plugin)
BuildRequires:  %{?scl_prefix_maven}mvn(org.osgi:osgi.annotation)

# OSGi BRs
BuildRequires:  %{?scl_prefix}eclipse-license
BuildRequires:  %{?scl_prefix}eclipse-egit
BuildRequires:  %{?scl_prefix}eclipse-m2e-core
BuildRequires:  %{?scl_prefix}eclipse-mylyn
BuildRequires:  %{?scl_prefix}eclipse-mylyn-context-java
BuildRequires:  %{?scl_prefix_maven}apache-commons-codec
BuildRequires:  %{?scl_prefix_maven}apache-commons-io
BuildRequires:  %{?scl_prefix_maven}apache-commons-lang3
BuildRequires:  %{?scl_prefix_maven}apache-commons-logging
BuildRequires:  %{?scl_prefix}apache-commons-math
BuildRequires:  %{?scl_prefix}apache-commons-pool
BuildRequires:  %{?scl_prefix_maven}guava
BuildRequires:  %{?scl_prefix_maven}google-gson
BuildRequires:  %{?scl_prefix}google-guice >= 4.1-8
BuildRequires:  %{?scl_prefix}guice-multibindings >= 4.1-8
BuildRequires:  %{?scl_prefix_maven}cglib
BuildRequires:  %{?scl_prefix_maven}objectweb-asm
BuildRequires:  %{?scl_prefix}lucene3
BuildRequires:  %{?scl_prefix}solr3
# Use old names for aether due to supporting F26 still
BuildRequires:  %{?scl_prefix}aether-api >= 1.1.0
BuildRequires:  %{?scl_prefix}aether-connector-basic >= 1.1.0
BuildRequires:  %{?scl_prefix}aether-impl >= 1.1.0
BuildRequires:  %{?scl_prefix}aether-spi >= 1.1.0
BuildRequires:  %{?scl_prefix}aether-transport-file >= 1.1.0
BuildRequires:  %{?scl_prefix}aether-transport-http >= 1.1.0
BuildRequires:  %{?scl_prefix}aether-util >= 1.1.0

Requires:       %{?scl_prefix}eclipse-platform
Requires:       %{?scl_prefix}google-guice >= 4.1-8
Requires:       %{?scl_prefix}guice-multibindings >= 4.1-8
Requires:       %{?scl_prefix_maven}cglib
Requires:       %{?scl_prefix_maven}objectweb-asm
# Use old names for aether due to supporting F26 still
Requires:       %{?scl_prefix}aether-api >= 1.1.0
Requires:       %{?scl_prefix}aether-connector-basic >= 1.1.0
Requires:       %{?scl_prefix}aether-impl >= 1.1.0
Requires:       %{?scl_prefix}aether-spi >= 1.1.0
Requires:       %{?scl_prefix}aether-transport-file >= 1.1.0
Requires:       %{?scl_prefix}aether-transport-http >= 1.1.0
Requires:       %{?scl_prefix}aether-util >= 1.1.0

%description
Code Recommenders automatically analyzes existing code using APIs and extracts
common usage rules and patterns from it. In the form of recommendation models,
this knowledge is then fed back into your IDE. Code Recommenders’ intelligent
code completion and augmented API documentation then utilizes the power of
these models to provide you with the solutions implemented by other developers
in the past. This helps you to get up to speed with the new framework or API
without countless hours of searching the Internet for the solutions to common
problems.

%prep
%{?scl:scl enable %{scl_maven} %{scl} - << "EOFSCL"}
set -e -x
%setup -q -n org.eclipse.recommenders-%{git_tag}
%patch0
%patch1

# Remove any pre-built binaries
find -name *.jar -delete
find -name *.class -delete

# Remove features that we don't need to ship
%pom_disable_module org.eclipse.recommenders.3rd.feature features

# No need to build update sites and target platforms for RPM builds
%pom_disable_module repositories
%pom_disable_module targets

# Remove use of tycho-sourceref-jgit (source is not a git repo)
%pom_remove_plugin org.eclipse.tycho:tycho-packaging-plugin
%pom_remove_plugin org.eclipse.tycho:target-platform-configuration

# Remove invokations of check plugins unnecessary for RPM builds
%pom_remove_plugin -r :animal-sniffer-maven-plugin
%pom_remove_plugin -r :maven-checkstyle-plugin
%pom_remove_plugin -r :maven-enforcer-plugin
%pom_remove_plugin -r :maven-jdeps-plugin
%pom_remove_plugin -r :maven-license-plugin
%pom_remove_plugin -r :tidy-maven-plugin

%if 0%{?fedora} == 26
# Bundles has a different BSN on older Fedoras
sed -i -e 's/org.apache.maven.resolver/org.eclipse.aether/' features/org.eclipse.recommenders.rcp.feature/feature.xml
%endif

# Relax dep on maven-resolver
sed -i -e '/aether/s/1\.0\.0,1\.1\.0/1.1.0,2.0.0/' plugins/org.eclipse.recommenders.models/META-INF/MANIFEST.MF

# Relax dep on guava and guice
sed -i -e '/com\.google\.common/s/;version="\[15.0.0,16.0.0)"//' $(find -name MANIFEST.MF)
sed -i -e '/com\.google\.inject/s/;bundle-version="\[3.0.0,4.0.0)"//' plugins/org.eclipse.recommenders.injection/META-INF/MANIFEST.MF
sed -i -e '/<import plugin="com/s/compatible/greaterOrEqual/' $(find features -name feature.xml)

# Fix dep on apache-commons-math -> apache-commons-math3
sed -i -e '/org.apache.commons.math/s/math/math3/;/org.apache.commons.math/s/2...0,3.0.0/3.0.0,4.0.0/' \
  plugins/org.eclipse.recommenders.jayes.transformation/META-INF/MANIFEST.MF \
  plugins/org.eclipse.recommenders.overrides/META-INF/MANIFEST.MF
sed -i -e '/import org.apache.commons.math/s/math/math3/' \
  plugins/org.eclipse.recommenders.jayes.transformation/src/org/eclipse/recommenders/jayes/transformation/*.java \
  plugins/org.eclipse.recommenders.overrides/src/org/eclipse/recommenders/overrides/*.java

# Use maven implementation from m2e
sed -i -e '/org.apache.maven.repository.internal/d' -e '/Require-Bundle/a\ org.eclipse.m2e.maven.runtime,' \
  plugins/org.eclipse.recommenders.models/META-INF/MANIFEST.MF
sed -i -e '/org.eclipse.aether.maven/d' features/org.eclipse.recommenders.rcp.feature/feature.xml

# Disable testing for now (requires xtext)
%pom_disable_module tests
%pom_disable_module org.eclipse.recommenders.testing.rcp.feature features
%pom_disable_module org.eclipse.recommenders.testing.rcp plugins
%pom_disable_module org.eclipse.recommenders.testing plugins
%pom_disable_module org.eclipse.recommenders.jayes.transformation plugins

# Don't install parent poms
%mvn_package "::pom::" __noinstall
%{?scl:EOFSCL}

%build
%{?scl:scl enable %{scl_maven} %{scl} - << "EOFSCL"}
set -e -x
# Qualifier generated from last modification time of source tarball
QUALIFIER=$(date -u -d"$(stat --format=%y %{SOURCE0})" +v%Y%m%d-%H%M)
%mvn_build  -j -- -DforceContextQualifier=$QUALIFIER
%{?scl:EOFSCL}

%install
%{?scl:scl enable %{scl_maven} %{scl} - << "EOFSCL"}
set -e -x
%mvn_install
%{?scl:EOFSCL}

%files -f .mfiles

%changelog
* Mon Jan 15 2018 Mat Booth <mat.booth@redhat.com> - 2.5.0-1.2
- Build against newer maven-resolver

* Sun Dec 17 2017 Mat Booth <mat.booth@redhat.com> - 2.5.0-1.1
- Auto SCL-ise package for rh-eclipse47 collection

* Sun Dec 17 2017 Mat Booth <mat.booth@redhat.com> - 2.5.0-1
- Update to Oxygen.2 release

* Mon Oct 02 2017 Mat Booth <mat.booth@redhat.com> - 2.4.10-3
- Simplify conditional

* Mon Oct 02 2017 Mat Booth <mat.booth@redhat.com> - 2.4.10-2
- Bump requirement on google-guice and rebuild to regenerate symlinks

* Sun Sep 17 2017 Mat Booth <mat.booth@redhat.com> - 2.4.10-1
- Update to Oxygen.1 release

* Mon Sep 04 2017 Mat Booth <mat.booth@redhat.com> - 2.4.9-2
- Fix build on F26
- Add dep on guice to fix dangling symlink

* Thu Aug 24 2017 Mat Booth <mat.booth@redhat.com> - 2.4.9-1
- Initial packaging
